diff --git a/drupal7/sites/all/modules/jquery_update/jquery_update.module b/drupal7/sites/all/modules/jquery_update/jquery_update.module
index 47b447f9..956c9e5a 100644
--- a/drupal7/sites/all/modules/jquery_update/jquery_update.module
+++ b/drupal7/sites/all/modules/jquery_update/jquery_update.module
@@ -94,6 +94,13 @@ function jquery_update_library_alter(&$javascript, $module) {
         $version = $admin_version;
       }
     }
+    // If the ajax version is set then that one always win.
+    if (!empty($_POST['ajax_page_state']['jquery_version'])) {
+      $ajax_version = $_POST['ajax_page_state']['jquery_version'];
+      if (in_array($ajax_version, array('default', '1.5', '1.6', '1.7', '1.8', '1.9', '1.10'))) {
+        $version = $ajax_version;
+      }
+    }
 
     // Always add a new jquery_version array to ajaxPageState.
     // This is what we used to determine which version to use
@@ -103,6 +110,12 @@ function jquery_update_library_alter(&$javascript, $module) {
       'type' => 'setting',
     );
     $javascript['drupal.ajax']['dependencies'][] = array('jquery_update', 'jquery_update.ajax.fix');
+
+    // Don't replace anything if Drupal provided jQuery should be used
+    if ('default' == $version) {
+      return;
+    }
+
     jquery_update_jquery_replace($javascript, $cdn, $path, $min, $version);
 
     // Replace jQuery UI with CDN or local files. If from a CDN include all of
@@ -163,6 +176,7 @@ function jquery_update_settings_form() {
     '#type' => 'select',
     '#title' => t('Default jQuery Version'),
     '#options' => array(
+      'default' => t('Default (provided by Drupal)'),
       '1.5' => '1.5',
       '1.7' => '1.7',
       '1.8' => '1.8',
@@ -177,7 +191,8 @@ function jquery_update_settings_form() {
     '#type' => 'select',
     '#title' => t('Alternate jQuery version for administrative pages'),
     '#options' => array(
-      '' => t('Use the default'),
+      '' => t('Default jQuery Version'),
+      'default' => t('Default (provided by Drupal)'),
       '1.5' => '1.5',
       '1.7' => '1.7',
       '1.8' => '1.8',
@@ -194,6 +209,12 @@ function jquery_update_settings_form() {
       'min' => t('Production (minified)'),
       'none' => t('Development (uncompressed)'),
     ),
+    // Do not show this field if jQuery version is default
+    '#states' => array(
+      'invisible' => array(
+        ':input[name=jquery_update_jquery_version]' => array('value' => "default"),
+      ),
+    ),
     '#default_value' => variable_get('jquery_update_compression_type', 'min'),
   );
   $form['jquery_update_jquery_cdn'] = array(
@@ -205,6 +226,12 @@ function jquery_update_settings_form() {
       'microsoft' => t('Microsoft'),
       'jquery' => t('jQuery'),
     ),
+    // Do not show this field if jQuery version is default
+    '#states' => array(
+      'invisible' => array(
+        ':input[name=jquery_update_jquery_version]' => array('value' => "default"),
+      ),
+    ),
     '#default_value' => variable_get('jquery_update_jquery_cdn', 'none'),
     '#description' => t('Use jQuery and jQuery UI from a CDN. If the CDN is not available the local version of jQuery and jQuery UI will be used.'),
   );
@@ -231,13 +258,6 @@ function jquery_update_settings_form() {
  *   The version of jQuery to use.
  */
 function jquery_update_jquery_replace(&$javascript, $cdn, $path, $min, $version) {
-  // If the ajax version is set then that one always win.
-  if (!empty($_POST['ajax_page_state']['jquery_version'])) {
-    $ajax_version = $_POST['ajax_page_state']['jquery_version'];
-    if (in_array($ajax_version, array('1.5', '1.6', '1.7', '1.8', '1.9', '1.10'))) {
-      $version = $ajax_version;
-    }
-  }
 
   // Make sure to use the latest version in given branch.
   $trueversion = NULL;
@@ -267,19 +287,19 @@ function jquery_update_jquery_replace(&$javascript, $cdn, $path, $min, $version)
   // Check for CDN support.
   switch ($cdn) {
     case 'google':
-      $javascript['jquery']['js']['misc/jquery.js']['data'] = 'https://ajax.googleapis.com/ajax/libs/jquery/' . $trueversion . '/jquery' . $min . '.js';
+      $javascript['jquery']['js']['misc/jquery.js']['data'] = '//ajax.googleapis.com/ajax/libs/jquery/' . $trueversion . '/jquery' . $min . '.js';
       $javascript['jquery']['js']['misc/jquery.js']['type'] = 'external';
       jquery_update_jquery_backup($javascript, $path, $min, $version);
       break;
 
     case 'microsoft':
-      $javascript['jquery']['js']['misc/jquery.js']['data'] = 'http://ajax.aspnetcdn.com/ajax/jQuery/jquery-' . $trueversion . $min . '.js';
+      $javascript['jquery']['js']['misc/jquery.js']['data'] = '//ajax.aspnetcdn.com/ajax/jQuery/jquery-' . $trueversion . $min . '.js';
       $javascript['jquery']['js']['misc/jquery.js']['type'] = 'external';
       jquery_update_jquery_backup($javascript, $path, $min, $version);
       break;
 
     case 'jquery':
-      $javascript['jquery']['js']['misc/jquery.js']['data'] = 'http://code.jquery.com/jquery-' . $trueversion . $min . '.js';
+      $javascript['jquery']['js']['misc/jquery.js']['data'] = '//code.jquery.com/jquery-' . $trueversion . $min . '.js';
       $javascript['jquery']['js']['misc/jquery.js']['type'] = 'external';
       jquery_update_jquery_backup($javascript, $path, $min, $version);
       break;
@@ -377,22 +397,26 @@ function jquery_update_jqueryui_replace(&$javascript, $cdn, $path, $min) {
     'ui.accordion', 'ui.autocomplete', 'ui.button', 'ui.datepicker', 'ui.dialog', 'ui.draggable',
     'ui.droppable', 'ui.mouse', 'ui.position', 'ui.progressbar', 'ui.resizable', 'ui.selectable',
     'ui.slider', 'ui.sortable', 'ui.tabs', 'ui.widget', 'ui.spinner', 'ui.menu', 'ui.tooltip',
-    'effects.blind', 'effects.bounce', 'effects.clip', 'effects.drop', 'effects.explode', 'effects.fade',
-    'effects.fold', 'effects.highlight', 'effects.pulsate', 'effects.scale', 'effects.shake', 'effects.slide',
-    'effects.transfer',
   ));
   $names['ui'] = 'ui.core';
-  $names['effects'] = 'ui.effect';
+  $names['effects'] = array('effects.core', 'ui.effect'); // map[library_hook] = array(core_fn, updated_fn)
+  $names = jquery_update_make_library_hook_to_file_name_segment_map_for_effects($names);
 
   switch ($cdn) {
     case 'google':
-      $cdn = 'https://ajax.googleapis.com/ajax/libs/jqueryui/1.10.2/jquery-ui' . $min . '.js';
+      $cdn = '//ajax.googleapis.com/ajax/libs/jqueryui/1.10.2/jquery-ui' . $min . '.js';
       jquery_update_jqueryui_cdn($cdn, $javascript, $path, $min, $names);
       jquery_update_jqueryui_backup($javascript, $path, $min);
       break;
 
     case 'microsoft':
-      $cdn = 'http://ajax.aspnetcdn.com/ajax/jquery.ui/1.10.2/jquery-ui' . $min . '.js';
+      $cdn = '//ajax.aspnetcdn.com/ajax/jquery.ui/1.10.2/jquery-ui' . $min . '.js';
+      jquery_update_jqueryui_cdn($cdn, $javascript, $path, $min, $names);
+      jquery_update_jqueryui_backup($javascript, $path, $min);
+      break;
+
+    case 'jquery':
+      $cdn = '//code.jquery.com/ui/1.10.2/jquery-ui' . $min . '.js';
       jquery_update_jqueryui_cdn($cdn, $javascript, $path, $min, $names);
       jquery_update_jqueryui_backup($javascript, $path, $min);
       break;
@@ -403,6 +427,30 @@ function jquery_update_jqueryui_replace(&$javascript, $cdn, $path, $min) {
   }
 }
 
+/**
+ * Create a mapping from system.module library hooks to file name segments.
+ *
+ * @param array $map Optional. If given, append to it.
+ * @return array The keys are library hooks  and the values are each arrays of
+ * 2 file name segments as values. The first file name segment can be used to
+ * reach Drupal core's jQuery UI effect files, and the second file name segment
+ * can be used to construct a path to the equivalent replacement
+ * jQuery UI effect file provided by jquery_update.module.
+ */
+function jquery_update_make_library_hook_to_file_name_segment_map_for_effects($map = array()) {
+  $effect_names = array(
+    'blind', 'bounce', 'clip', 'drop', 'explode', 'fade', 'fold',
+    'highlight', 'pulsate', 'scale', 'shake', 'slide', 'transfer',
+  );
+  foreach ($effect_names as $effect_name) {
+    $library_hook = 'effects.' . $effect_name;
+    $file_name_segment_core = $library_hook; // Yes, for the effect files, this is indeed identical.
+    $file_name_segment_updated = 'ui.effect-' . $effect_name;
+    $map[$library_hook] = array($file_name_segment_core, $file_name_segment_updated);
+  }
+  return $map;
+}
+
 /**
  * Add the local fallback in case jQuery UI from the CDN is unavailable.
  *
@@ -447,7 +495,8 @@ function jquery_update_jqueryui_cdn($cdn, &$javascript, $path, $min, $names) {
   // Construct the jQuery UI path and replace the JavaScript.
   $jspath = $path . '/replace/ui/ui/' . ($min == '.min' ? 'minified/' : '');
   foreach ($names as $name => $file) {
-    $corefile = 'misc/ui/jquery.' . $file . '.min.js';
+    list($file_core, $file_updated) = is_array($file) ? $file : array($file, $file);
+    $corefile = 'misc/ui/jquery.' . $file_core . '.min.js';
     // Remove the core files.
     unset($javascript[$name]['js'][$corefile]);
     $javascript[$name]['version'] = '1.10.2';
@@ -487,8 +536,9 @@ function jquery_update_jqueryui_local(&$javascript, $path, $min, $names) {
   // Construct the jQuery UI path and replace the JavaScript.
   $jspath = $path . '/replace/ui/ui/' . ($min == '.min' ? 'minified/' : '');
   foreach ($names as $name => $file) {
-    $corefile = 'misc/ui/jquery.' . $file . '.min.js';
-    $javascript[$name]['js'][$corefile]['data'] = $jspath . 'jquery.' . $file . $min . '.js';
+    list($file_core, $file_updated) = is_array($file) ? $file : array($file, $file);
+    $corefile = 'misc/ui/jquery.' . $file_core . '.min.js';
+    $javascript[$name]['js'][$corefile]['data'] = $jspath . 'jquery.' . $file_updated . $min . '.js';
     $javascript[$name]['version'] = '1.10.2';
   }
 }
diff --git a/drupal7/sites/all/modules/panels/i18n_panels/i18n_panels.info b/drupal7/sites/all/modules/panels/i18n_panels/i18n_panels.info
index dc8bab0a..13838a1f 100644
--- a/drupal7/sites/all/modules/panels/i18n_panels/i18n_panels.info
+++ b/drupal7/sites/all/modules/panels/i18n_panels/i18n_panels.info
@@ -7,9 +7,9 @@ dependencies[] = i18n_translation
 package = Multilingual - Internationalization
 core = 7.x
 
-; Information added by Drupal.org packaging script on 2014-02-12
-version = "7.x-3.4"
+; Information added by Drupal.org packaging script on 2015-01-28
+version = "7.x-3.5"
 core = "7.x"
 project = "panels"
-datestamp = "1392221614"
+datestamp = "1422472985"
 
diff --git a/drupal7/sites/all/modules/panels/includes/add-content.inc b/drupal7/sites/all/modules/panels/includes/add-content.inc
index 0a52ff92..dc0be48f 100644
--- a/drupal7/sites/all/modules/panels/includes/add-content.inc
+++ b/drupal7/sites/all/modules/panels/includes/add-content.inc
@@ -77,7 +77,10 @@ function template_preprocess_panels_add_content_link(&$vars) {
   $vars['description'] = isset($vars['content_type']['description']) ? $vars['content_type']['description'] : $vars['title'];
   $vars['icon'] = ctools_content_admin_icon($vars['content_type']);
   $vars['url'] = $vars['renderer']->get_url('add-pane', $vars['region'], $vars['content_type']['type_name'], $vars['content_type']['subtype_name']);
-
-  $vars['image_button'] = ctools_ajax_image_button($vars['icon'], $vars['url'], $vars['description'], 'panels-modal-add-config');
-  $vars['text_button'] = ctools_ajax_text_button($vars['title'], $vars['url'], $vars['description'], 'panels-modal-add-config');
+  $subtype_class = 'add-content-link-' . str_replace('_', '-', $vars['content_type']['subtype_name']);
+  $vars['image_button'] = ctools_ajax_image_button($vars['icon'], $vars['url'], $vars['description'], $subtype_class . '-image-button panels-modal-add-config');
+  $vars['text_button'] = ctools_ajax_text_button($vars['title'], $vars['url'], $vars['description'], $subtype_class . '-text-button panels-modal-add-config');
+  if (function_exists('ctools_ajax_icon_text_button')) {
+    $vars['icon_text_button'] = ctools_ajax_icon_text_button($vars['title'], $vars['icon'], $vars['url'], $vars['description'], $subtype_class . '-icon-text-button panels-modal-add-config');
+  }
 }
diff --git a/drupal7/sites/all/modules/panels/includes/display-edit.inc b/drupal7/sites/all/modules/panels/includes/display-edit.inc
index dc6d1b91..4e282924 100644
--- a/drupal7/sites/all/modules/panels/includes/display-edit.inc
+++ b/drupal7/sites/all/modules/panels/includes/display-edit.inc
@@ -240,7 +240,7 @@ function panels_edit_display_settings_form($form, &$form_state) {
       '#type' => 'textfield',
       '#default_value' => $display->title,
       '#title' => t('Title'),
-      '#description' => t('The title of this panel. If left blank, a default title may be used. Set to No Title if you want the title to actually be blank.'),
+      '#description' => t('The title of this panel. If left blank, a default title may be used. If you want the title actually to be blank, change the "Title type" dropdown from "Manually Set" to "No Title".'),
       '#process' => array('ctools_dependent_process'),
       '#dependency' => array('edit-display-title-hide-title' => array(PANELS_TITLE_FIXED)),
       '#maxlength' => 255,
diff --git a/drupal7/sites/all/modules/panels/includes/display-layout.inc b/drupal7/sites/all/modules/panels/includes/display-layout.inc
index ad051b45..b4687e2a 100644
--- a/drupal7/sites/all/modules/panels/includes/display-layout.inc
+++ b/drupal7/sites/all/modules/panels/includes/display-layout.inc
@@ -94,6 +94,7 @@ function panels_choose_layout($form, &$form_state) {
     }
   }
 
+  ctools_add_js('panels-base', 'panels');
   ctools_add_js('layout', 'panels');
 
   $form['categories'] = array(
diff --git a/drupal7/sites/all/modules/panels/js/display_editor.js b/drupal7/sites/all/modules/panels/js/display_editor.js
index 40e11463..53274f68 100644
--- a/drupal7/sites/all/modules/panels/js/display_editor.js
+++ b/drupal7/sites/all/modules/panels/js/display_editor.js
@@ -80,7 +80,7 @@ Drupal.Panels.Draggable = {
   regionId: 'panel-region-',
 
   // What to add to the front of a the id to get the form id for a panel
-  formId: 'input#edit-',
+  formId: '#edit-',
 
   maxWidth: 250,
 
@@ -492,8 +492,8 @@ Drupal.behaviors.PanelsDisplayEditor = {
     Drupal.Panels.Draggable.savePositions();
 
     // Bind buttons.
-    $('input#panels-hide-all', context).click(Drupal.Panels.clickHideAll);
-    $('input#panels-show-all', context).click(Drupal.Panels.clickShowAll);
+    $('#panels-hide-all', context).click(Drupal.Panels.clickHideAll);
+    $('#panels-show-all', context).click(Drupal.Panels.clickShowAll);
 
     Drupal.Panels.bindClickDelete(context);
 
@@ -513,6 +513,11 @@ Drupal.behaviors.PanelsDisplayEditor = {
         $('#panels-preview').html(html);
       });
 
+    // Bind modal detach behaviors to cancel current form.
+    $(document).bind('CToolsDetachBehaviors', function(event, context) {
+      $('#edit-cancel-style', context).trigger('click');
+    });
+
     var setTitleClass = function () {
       if ($('#edit-display-title-hide-title').val() == 2) {
         $('#panels-dnd-main').removeClass('panels-set-title-hide');
diff --git a/drupal7/sites/all/modules/panels/panels.info b/drupal7/sites/all/modules/panels/panels.info
index 797666f9..5eb4db15 100644
--- a/drupal7/sites/all/modules/panels/panels.info
+++ b/drupal7/sites/all/modules/panels/panels.info
@@ -2,17 +2,18 @@ name = Panels
 description = Core Panels display functions; provides no external UI, at least one other Panels module should be enabled.
 core = 7.x
 package = "Panels"
+version = PANELS_VERSION
 configure = admin/structure/panels
-dependencies[] = ctools (>=1.4)
+dependencies[] = ctools (>1.5)
 files[] = panels.module
 files[] = includes/common.inc
 files[] = includes/legacy.inc
 files[] = includes/plugins.inc
 files[] = plugins/views/panels_views_plugin_row_fields.inc
 
-; Information added by Drupal.org packaging script on 2014-02-12
-version = "7.x-3.4"
+; Information added by Drupal.org packaging script on 2015-01-28
+version = "7.x-3.5"
 core = "7.x"
 project = "panels"
-datestamp = "1392221614"
+datestamp = "1422472985"
 
diff --git a/drupal7/sites/all/modules/panels/panels.install b/drupal7/sites/all/modules/panels/panels.install
index b913012a..1d82544b 100644
--- a/drupal7/sites/all/modules/panels/panels.install
+++ b/drupal7/sites/all/modules/panels/panels.install
@@ -17,7 +17,7 @@ function panels_requirements_install() {
   // Assume that if the user is running an installation profile that both
   // Panels and CTools are the same release.
   if (!(defined('MAINTENANCE_MODE') && MAINTENANCE_MODE == 'install')) {
-    // apparently the install process doesn't include .module files,
+    // Apparently the install process doesn't include .module files,
     // so we need to force the issue in order for our versioning
     // check to work.
     if (!defined('PANELS_REQUIRED_CTOOLS_API')) {
@@ -30,24 +30,32 @@ function panels_requirements_install() {
       include_once drupal_get_path('module', 'ctools') . '/ctools.module';
     }
     if (!module_invoke('ctools', 'api_version', PANELS_REQUIRED_CTOOLS_API)) {
-       $requirements['panels_ctools'] = array(
-         'title' => $t('CTools API Version'),
-         'value' => CTOOLS_API_VERSION,
-         'severity' => REQUIREMENT_ERROR,
-         'description' => t('The CTools API version is too old for Panels. Panels needs at least %version.', array('%version' => PANELS_REQUIRED_CTOOLS_API))
-       );
+      $requirements['panels_ctools'] = array(
+        'title' => $t('CTools API Version'),
+        'value' => CTOOLS_API_VERSION,
+        'severity' => REQUIREMENT_ERROR,
+        'description' => t('The CTools API version is too old for Panels. Panels needs at least %version.', array('%version' => PANELS_REQUIRED_CTOOLS_API)),
+      );
     }
   }
   return $requirements;
 }
 
 /**
- * Implementation of hook_schema().
+ * Implements of hook_schema().
  */
 function panels_schema() {
-  // This should always point to our 'current' schema. This makes it relatively easy
-  // to keep a record of schema as we make changes to it.
-  return panels_schema_5();
+  // This should always point to our 'current' schema. This makes it relatively
+  // easy to keep a record of schema as we make changes to it.
+  return panels_schema_6();
+}
+
+function panels_schema_6() {
+  $schema = panels_schema_5();
+
+  $schema['cache_panels'] = drupal_get_schema_unprocessed('system', 'cache');
+
+  return $schema;
 }
 
 function panels_schema_5() {
@@ -351,8 +359,6 @@ function panels_schema_3() {
     'primary key' => array('lid'),
   );
 
-  $schema['cache_panels'] = drupal_get_schema_unprocessed('system', 'cache');
-
   return $schema;
 }
 
@@ -402,6 +408,9 @@ function panels_update_7301() {
  * Adding universally unique identifiers to panels.
  */
 function panels_update_7302() {
+  if (!module_load_include('inc', 'ctools', 'includes/uuid')) {
+    throw new DrupalUpdateException(t('Ctools UUID support not detected. You must update to a more recent version of the ctools module.'));
+  }
   // Load the schema.
   $schema = panels_schema_5();
   $msg = array();
@@ -453,6 +462,11 @@ function panels_update_7302() {
 
   $dids = array_unique(array_merge($display_dids, $pane_dids));
 
+  // If the Panels module is disabled we don't have access to
+  // panels_load_displays().
+  if (!function_exists('panels_load_displays')) {
+    module_load_include('module', 'panels');
+  }
   if ($displays = panels_load_displays($dids)) {
     foreach ($displays as $display) {
       // A display save also triggers pane saves.
@@ -471,9 +485,10 @@ function panels_update_7302() {
  * Add a custom cache table for Panels.
  */
 function panels_update_7303() {
+  $schema = panels_schema_6();
+
   $table_name = 'cache_panels';
   if (!db_table_exists($table_name)) {
-    $schema = drupal_get_schema_unprocessed('system', 'cache');
-    db_create_table($table_name, $schema);
+    db_create_table($table_name, $schema[$table_name]);
   }
 }
diff --git a/drupal7/sites/all/modules/panels/panels.module b/drupal7/sites/all/modules/panels/panels.module
index 1ca8b496..1136ddb0 100644
--- a/drupal7/sites/all/modules/panels/panels.module
+++ b/drupal7/sites/all/modules/panels/panels.module
@@ -6,7 +6,22 @@
  * Core functionality for the Panels engine.
  */
 
-define('PANELS_REQUIRED_CTOOLS_API', '2.0-alpha');
+define('PANELS_REQUIRED_CTOOLS_API', '2.0.8');
+
+/**
+ * The current working panels version.
+ *
+ * In a release, it should be 7.x-3.x, which should match what drush make will
+ * create. In a dev format, it should be 7.x-3.(x+1)-dev, which will allow
+ * modules depending on new features in panels to depend on panels > 7.x-3.x.
+ *
+ * To define a specific version of Panels as a dependency for another module,
+ * simply include a dependency line in that module's info file, e.g.:
+ *   ; Requires Panels v7.x-3.4 or newer.
+ *   dependencies[] = panels (>=3.4)
+ */
+define('PANELS_VERSION', '7.x-3.5');
+
 
 define('PANELS_TITLE_FIXED', 0); // Hide title use to be true/false. So false remains old behavior.
 define('PANELS_TITLE_NONE', 1); // And true meant no title.
@@ -43,7 +58,7 @@ function panels_theme() {
     'variables' => array('id' => NULL, 'image' => NULL, 'title' => NULL),
   );
   $theme['panels_pane'] = array(
-    'variables' => array('output' => array(), 'pane' => array(), 'display' => array()),
+    'variables' => array('content' => array(), 'pane' => array(), 'display' => array()),
     'path' => drupal_get_path('module', 'panels') . '/templates',
     'template' => 'panels-pane',
   );
@@ -269,7 +284,7 @@ function panels_permission() {
   return array(
     'use panels dashboard' => array(
       'title' => t("Use Panels Dashboard"),
-      'description' => t("Allows a user to access the !link.", array('!link' => l('Panels Dashboard', 'admin/structure/panels'))),
+      'description' => t('Allows a user to access the <a href="@url">Panels Dashboard</a>.', array('@url' => url('admin/structure/panels'))),
     ),
     'view pane admin links' => array( // @todo
       'title' => t("View administrative links on Panel panes"),
@@ -329,7 +344,9 @@ function panels_permission() {
  * Implements hook_flush_caches().
  */
 function panels_flush_caches() {
-  return array('cache_panels');
+  if (db_table_exists('cache_panels')) {
+    return array('cache_panels');
+  }
 }
 
 // ---------------------------------------------------------------------------
@@ -786,6 +803,7 @@ function panels_new_pane($type, $subtype, $set_defaults = FALSE) {
     $content_subtype = ctools_content_get_subtype($content_type, $subtype);
     $pane->configuration = ctools_content_get_defaults($content_type, $content_subtype);
   }
+  drupal_alter('panels_new_pane', $pane);
 
   return $pane;
 }
@@ -1316,6 +1334,7 @@ function template_preprocess_panels_pane(&$vars) {
   $vars['pane_suffix'] = !empty($content->pane_suffix) ? $content->pane_suffix : '';
 
   $vars['title'] = !empty($content->title) ? $content->title : '';
+  $vars['title_heading'] = !empty($content->title_heading) ? $content->title_heading : 'h2';
   $vars['title_attributes_array']['class'][] = 'pane-title';
 
   $vars['feeds'] = !empty($content->feeds) ? implode(' ', $content->feeds) : '';
@@ -1772,6 +1791,98 @@ function _panels_builder_filter($layout) {
   return empty($layout['builder']);
 }
 
+/**
+ * Implements hook_get_pane_links_alter().
+ *
+ * add links to the Panels pane dropdown menu.
+ */
+function panels_get_pane_links_alter(&$links, $pane, $content_type) {
+  if ($pane->type === "block"){
+    $prefixed_name = $pane->subtype;
+
+    // breakup the subtype string into parts.
+    $exploded_subtype = explode('-', $pane->subtype);
+
+    // get the first part of the string.
+    $subtype_prefix = $exploded_subtype[0];
+
+    // get the first part of the string and add a hyphen.
+    $subtype_prefix_hyphen = $exploded_subtype[0] . '-';
+
+    // remove the prefix block- to get the name.
+    $name_of_block = ltrim( $prefixed_name, $subtype_prefix_hyphen);
+
+    // check for user added menus created at /admin/structure/menu/add
+    // menus of that type have a subtype that is prefixed with menu-menu-
+    if (substr($prefixed_name, 0, 10) === "menu-menu-"){
+      // remove the first prefix menu- from menu-menu- to get the name.
+      $name_of_block = substr($prefixed_name, 5);
+
+      $links['top'][] = array(
+        'title' => t('Edit block'),
+        'href' => url('admin/structure/block/manage/' . $subtype_prefix . '/' . $name_of_block . '/configure', array('absolute' => TRUE)),
+        'attributes' => array('target' => array('_blank')),
+      );
+
+      $links['top'][] = array(
+        'title' => t('Edit menu links'),
+        'href' => url('admin/structure/menu/manage/' . $name_of_block, array('absolute' => TRUE)),
+        'attributes' => array('target' => array('_blank')),
+      );
+    }
+
+    // check for module provided menu blocks like Devels or Features
+    // menus of that type have a subtype that is prefixed with menu-
+    elseif(substr($prefixed_name, 0, 5) === "menu-"){
+      // remove the first prefix menu- to get the name.
+      $name_of_block = substr($prefixed_name, 5);
+
+      $links['top'][] = array(
+        'title' => t('Edit block'),
+        'href' => url('admin/structure/block/manage/' . $subtype_prefix . '/' . $name_of_block . '/configure', array('absolute' => TRUE)),
+        'attributes' => array('target' => array('_blank')),
+      );
+
+      $links['top'][] = array(
+        'title' => t('Edit menu links'),
+        'href' => url('admin/structure/menu/manage/' . $name_of_block, array('absolute' => TRUE)),
+        'attributes' => array('target' => array('_blank')),
+      );
+    }
+
+    // check for system blocks with menu links
+    elseif(substr($prefixed_name, 0, 7) === "system-") {
+      // remove the first prefix system- to get the name
+      $name_of_block = substr($prefixed_name, 7);
+
+      $names_of_system_menus = menu_list_system_menus();
+
+      $links['top'][] = array(
+        'title' => t('Edit block'),
+        'href' => url('admin/structure/block/manage/' . $subtype_prefix . '/' . $name_of_block . '/configure', array('absolute' => TRUE)),
+        'attributes' => array('target' => array('_blank')),
+      );
+
+      if (array_key_exists($name_of_block, $names_of_system_menus)){
+        $links['top'][] = array(
+          'title' => t('Edit menu links'),
+          'href' => url('admin/structure/menu/manage/' . $name_of_block, array('absolute' => TRUE)),
+          'attributes' => array('target' => array('_blank')),
+        );
+      }
+    }
+
+    // for all other blocks without menus
+    else{
+      $links['top'][] = array(
+        'title' => t('Edit block'),
+        'href' => url('admin/structure/block/manage/' . $subtype_prefix . '/' . $name_of_block . '/configure', array('absolute' => TRUE)),
+        'attributes' => array('target' => array('_blank')),
+      );
+    }
+  }
+}
+
 // --------------------------------------------------------------------------
 // Deprecated functions
 //
@@ -1791,7 +1902,7 @@ function panels_get_path($file, $base_path = FALSE, $module = 'panels') {
 function panels_preprocess_html(&$vars) {
   $panel_body_css = &drupal_static('panel_body_css');
   if (!empty($panel_body_css['body_classes_to_remove'])) {
-    $classes_to_remove = explode(' ', $panel_body_css['body_classes_to_remove']);
+    $classes_to_remove = array_filter(explode(' ', $panel_body_css['body_classes_to_remove']), 'strlen');
     foreach ($vars['classes_array'] as $key => $css_class) {
       if (in_array($css_class, $classes_to_remove)) {
         unset($vars['classes_array'][$key]);
diff --git a/drupal7/sites/all/modules/panels/panels_ipe/js/panels_ipe.js b/drupal7/sites/all/modules/panels/panels_ipe/js/panels_ipe.js
index aad076dc..b203f5e5 100644
--- a/drupal7/sites/all/modules/panels/panels_ipe/js/panels_ipe.js
+++ b/drupal7/sites/all/modules/panels/panels_ipe/js/panels_ipe.js
@@ -215,7 +215,7 @@ function DrupalPanelsIPE(cache_key, cfg) {
 
     $('.panels-ipe-form-container', ipe.control).append(formdata);
 
-    $('input:submit:not(.ajax-processed)', ipe.control).addClass('ajax-processed').each(function() {
+    $('input:submit:not(.ajax-processed), button:not(.ajax-processed)', ipe.control).addClass('ajax-processed').each(function() {
       var element_settings = {};
 
       element_settings.url = $(this.form).attr('action');
@@ -285,7 +285,7 @@ function DrupalPanelsIPE(cache_key, cfg) {
           val += id;
         }
       });
-      $('input[name="panel[pane][' +  region + ']"]', ipe.control).val(val);
+      $('[name="panel[pane][' +  region + ']"]', ipe.control).val(val);
     });
   }
 
diff --git a/drupal7/sites/all/modules/panels/panels_ipe/panels_ipe.info b/drupal7/sites/all/modules/panels/panels_ipe/panels_ipe.info
index 7fbb6e96..6ebaf5c9 100644
--- a/drupal7/sites/all/modules/panels/panels_ipe/panels_ipe.info
+++ b/drupal7/sites/all/modules/panels/panels_ipe/panels_ipe.info
@@ -1,14 +1,15 @@
 name = Panels In-Place Editor
 description = Provide a UI for managing some Panels directly on the frontend, instead of having to use the backend.
 package = "Panels"
+version = PANELS_VERSION
 dependencies[] = panels
 core = 7.x
 configure = admin/structure/panels
 files[] = panels_ipe.module
 
-; Information added by Drupal.org packaging script on 2014-02-12
-version = "7.x-3.4"
+; Information added by Drupal.org packaging script on 2015-01-28
+version = "7.x-3.5"
 core = "7.x"
 project = "panels"
-datestamp = "1392221614"
+datestamp = "1422472985"
 
diff --git a/drupal7/sites/all/modules/panels/panels_ipe/panels_ipe.module b/drupal7/sites/all/modules/panels/panels_ipe/panels_ipe.module
index c3096843..a11fc3ae 100644
--- a/drupal7/sites/all/modules/panels/panels_ipe/panels_ipe.module
+++ b/drupal7/sites/all/modules/panels/panels_ipe/panels_ipe.module
@@ -133,18 +133,22 @@ function template_preprocess_panels_ipe_pane_wrapper(&$vars) {
 function theme_panels_ipe_pane_wrapper($vars) {
   $output = $vars['output'];
   $pane = $vars['pane'];
+  $display = $vars['display'];
 
   $attributes = array(
     'class' => 'panels-ipe-linkbar',
   );
 
+  $type = ctools_get_content_type($pane->type);
+  $title ='<span class = "panels-ipe-dragbar-admin-title">' . ctools_content_admin_title($type, $pane->subtype, $pane->configuration, $display->context) . '</span>';
+
   $links = theme('links', array('links' => $vars['links'], 'attributes' => $attributes));
 
   if (!empty($pane->locks['type']) && $pane->locks['type'] == 'immovable') {
-    $links = '<div class="panels-ipe-dragbar panels-ipe-nodraghandle clearfix">' . $links . '</div>';
+    $links = '<div class="panels-ipe-dragbar panels-ipe-nodraghandle clearfix">' . $links .$title .'</div>';
   }
   else {
-    $links = '<div class="panels-ipe-dragbar panels-ipe-draghandle clearfix">' . $links . '<span class="panels-ipe-draghandle-icon"><span class="panels-ipe-draghandle-icon-inner"></span></span></div>';
+    $links = '<div class="panels-ipe-dragbar panels-ipe-draghandle clearfix">' . $links . $title . '<span class="panels-ipe-draghandle-icon"><span class="panels-ipe-draghandle-icon-inner"></span></span></div>';
   }
 
   $handlebar = '<div class="panels-ipe-handlebar-wrapper panels-ipe-on">' . $links . '</div>';
